# Copyright (c) 2006-2008 oc2pus
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to toni@links2linux.de

# norootforbuild

%ifarch x86_64
%define _jvm_lib_ext_dir	%{_jvmdir}/jre/lib/amd64
%else
%define _jvm_lib_ext_dir	%{_jvmdir}/jre/lib/i386
%endif
%define _cvs_version	20110107

Name:			tritonus
Summary:		Tritonus - A implementation of the Java Sound API
URL:			http://www.tritonus.org/
Group:			Development/Java
Version:		0.3.7
Release:		%mkrel 0.0.%{_cvs_version}.7
License:		LGPLv2+
# cvs -d:pserver:anonymous@tritonus.cvs.sourceforge.net:/cvsroot/tritonus login
# cvs -z3 -d:pserver:anonymous@tritonus.cvs.sourceforge.net:/cvsroot/tritonus co tritonus
# cp -far tritonus tritonus-0.3.7
# find tritonus-0.3.7 -name CVS -type d -exec rm -fr {} \; 2> /dev/null
# tar Jcf tritonus-0.3.7.tar.xz tritonus-0.3.7
Source0:		%{name}-%{version}.tar.xz
Source1:		%{name}-Mp3Encoder.java
Source9:		%{name}-snapshot.sh
Patch0:			%{name}-configure.in.diff
Patch1:			%{name}-src-lib-fluidsynth.Makefile.in.diff
Patch2:			%{name}-src-lib-alsa-Makefile.in.diff
Patch3:			%{name}-src-lib-alsa-constants_check.h.diff
Patch4:			%{name}-removed-code.diff
Patch5:			%{name}-build-common.diff
Patch6:			%{name}-build.diff
Patch7:			%{name}-configure.in-JDK-version-check.diff
Patch8:			%{name}-0.3.7-nonascii.patch
BuildRequires:	ant
BuildRequires:	apache-commons-net
BuildRequires:	java-devel
BuildRequires:	javapackages-tools
BuildRequires:	libalsa-devel >= 0.9
BuildRequires:	libcdda-devel
BuildRequires:	ncurses-devel
BuildRequires:	e2fsprogs-devel
BuildRequires:	jlayer
BuildRequires:	jorbis
BuildRequires:	jpackage-utils >= 1.5
BuildRequires:	lash-devel
BuildRequires:	libfluidsynth-devel
BuildRequires:	libjack-devel
BuildRequires:	libogg-devel
BuildRequires:	libvorbis-devel
BuildRequires:	ncurses-devel
BuildRequires:	readline-devel
BuildRequires:	unzip
BuildRequires:	update-alternatives
BuildRequires:	xml-commons-apis
BuildRequires:  libtool
Requires:		apache-commons-logging
Requires:		java >= 1.5
Requires:		jpackage-utils >= 1.5
Requires:		jlayer
Requires:		jorbis
Requires:		alsa >= 0.9
# requires for virtual package:
Requires:		tritonus-alsa
Requires:		tritonus-aos
Requires:		tritonus-cdda
Requires:		tritonus-core
Requires:		tritonus-dsp
Requires:		tritonus-fluidsynth
Requires:		tritonus-javasequencer
Requires:		tritonus-jorbis
Requires:		tritonus-gsm
Requires:		tritonus-mp3
%if 0
Requires:		tritonus-mp3enc
%endif
Requires:		tritonus-pvorbis
Requires:		tritonus-shared
Requires:		tritonus-src
Requires:		tritonus-vorbis
Recommends:		tritonus-javadoc

%description
Virtual package to install all tritonus-plugins.

Tritonus is an implementation of the Java Sound API.

Currently, GNU/Linux i386 and Linux/PowerPC is supported. Some
separately downloadable plugins also run on other JavaSound
platforms. Support for other platforms is planned for the future.

Tritonus is distributed under the terms of the GNU Library General
Public License.

%package javadoc
Summary:	Javadoc for tritonus
Group:		Development/Java
Requires:	%{name} = %{version}-%{release}

%description javadoc
Javadoc for tritonus.

%package shared
Summary:	Shared classes required by all other Tritonus plug-ins
Group:		Development/Java
Obsoletes:	tritonus-esd

%description shared
Shared classes required by all other Tritonus plug-ins.

%package jorbis
Summary:	A plug-in for Java that enables decoding of Ogg Vorbis bitstreams
Group:		Development/Java
Requires:	jorbis
Requires:	%{name}-shared

%description jorbis
A plug-in for Java that enables decoding of Ogg Vorbis bitstreams.
It is based on the pure-java decoder implementation of JCraft. The
decoder runs in real-time even on old machines, as long as your
Java runtime has a JIT-Compiler (most contemporary have).

%package vorbis
Summary:	A plug-in for Java that enables encoding to Ogg Vorbis bitstreams
Group:		Development/Java
Requires:	vorbis-java
Requires:	%{name}-shared

%description vorbis
A plug-in for Java that enables encoding to Ogg Vorbis bitstreams.
It is based on the native vorbis libraries.

%package pvorbis
Summary:	A plug-in for Java that enables encoding to Ogg Vorbis bitstreams
Group:		Development/Java
Requires:	jorbis
Requires:	%{name}-shared

%description pvorbis
A plug-in for Java that enables encoding to Ogg Vorbis bitstreams.

%package cdda
Summary:	A plug-in for Java that enables you to digitally read audio CD's
Group:		Development/Java
Requires:	cdparanoia >= IIIalpha9.8
Requires:	%{name}-shared

%description cdda
A plug-in for Java that enables you to digitally read audio CD's.

The download package contains the library for Linux/i386, tritonus_cdda.jar,
source code, and detailed instructions.

A demo program was presented at the JavaOne 2002 conference:
Ripping and Encoding to MP3 with the Java Sound API.
See: http://www.jsresources.org/apps/ripper/

%package mp3
Summary:	MP3 Decoder
Group:		Development/Java
Requires:	%{name}-shared
Requires:	jlayer

%description mp3
MP3-Devoder.

%if 0
%package mp3enc
Summary:	A plug-in for Java that enables mp3 encoding with Java Sound
Group:		Development/Java
Requires:	lame
Requires:	%{name}-shared
Requires:	%{name}-mp3

%description mp3enc
A plug-in for Java that enables mp3 encoding with Java Sound.

The download package contains the native libraries for Linux/i386,
detailed instructions, and a test program.
%endif

%package gsm
Summary:	GSM codec
Group:		Development/Java
Requires:	%{name}-shared

%description gsm
For examples of using the GSM codec, refer to the Java Sound Resources examples
GSMEncoder, AudioDecoder  and DecodingAudioPlayer:
http://www.jsresources.org/
http://www.jsresources.org/examples/GSMEncoder.html
http://www.jsresources.org/examples/AudioDecoder.html
http://www.jsresources.org/examples/DecodingAudioPlayer.html

%package javasequencer
Summary:	A Java-Sequencer
Group:		Development/Java
Requires:	%{name}-shared

%description javasequencer
Note that for this sequencer to provide stable timing, three
conditions have to be met:

1. System.currentTimeMillis() has to do what its name says:
provide the system time in milliseconds. Some lecacy operating
systems (Windows & co.) provide a timer resolution of only 10,
30 or 60 ms. For information on what you can expect on your
operating system, see the measurements of YIP Chi Lap [Beta]

2. A synthesizer or MIDI port implementation that responds
immediately.
Testing with the synthesizer of the Sun implementation resulted
in horrible timing. Timing with the hardware synthesizer of a
SB Life!, accessed via ALSA, was very good. Working with
WireProvider should be ok, too (assuming you manage to meet
the first point)

3. Small scheduling latencies. On the GNU/Linux system I tested,
even heavy file system traffic didn't lead to noticeable effects
on the timing. However, usage of the X server almost always led
to delays. This is due to the fact that the X server normally
runs with very high scheduling priority, stealing other processes
CPU time. Moving a window killed the timing. Even a running 'top'
was noticeable.

For testing with this sequencer, I recommend to use a recent
version of MidiPlayer from the Java Sound Examples.

%package alsa
Summary:	Implementations of javax.sound.sampled.Mixer and javax.sound.midi.MidiDevice based on ALSA
Group:		Development/Java
Requires:	alsa >= 0.9
Requires:	%{name}-shared

%description alsa
Implementations of javax.sound.sampled.Mixer and javax.sound.midi.MidiDevice
based on ALSA.

It provides (most of) the capabilities of ALSA pcm and seq to Java
Sound.
Especially, you can use this mixer to get full-duplex support and
MIDI in/out plus a very stable sequencer for Java Sound on Linux.

%package dsp
Summary:	A collection of classes for digital signal processing (DSP)
Group:		Development/Java
Requires:	%{name}-shared

%description dsp
A collection of classes for digital signal processing (DSP).

For an example of how to use it, see AmplitudeConverter in the examples
section of the Java Sound Resources.

%package aos
Summary:	An add-on to the Java Sound API
Group:		Development/Java
Requires:	%{name}-shared

%description aos
An add-on to the Java Sound API.

The AudioOutputStream architecture allow writing of audio data to
audio files. Supported types are .wav, .aiff and .au. It is an
alternative to using AudioSystem.write(). The advantage over
AudioSystem.write() is that with the AudioOutputStream architecture,
you can code your own main loop writing to the audio file.
The AudioOutputStream architecture implements a 'push' approach for
audio data, while AudioSystem.write() works with a "pull" approach.
In many situations, a 'push' approach is more flexible.

For an example of using the AudioOutputStream architecture, see the
examples on Java Sound Resources. There is an examples
OscillatorFileAOS using the AudioOutputStream architecture.

%package misc
Summary:	Plug-in with several service provider of Tritonus
Group:		Development/Java
Requires:	%{name}-shared

%description misc
Plug-in with several service provider of Tritonus.

It contains the PCM2PCM converter, A-law and U-law converters,
sample rate converter, ADPCM converters, audio file readers
and writers and MIDI file readers and writers.

For an example of how to use the sample rate converter, see
SampleRateConverter.
http://www.jsresources.org/examples/SampleRateConverter.html

%package fluidsynth
Summary:	Plug-in for fluidsynth
Group:		Development/Java
Requires:	%{name}-shared
Requires:	fluidsynth
Requires:	ncurses
Requires:	jack

%description fluidsynth
Plug-in for fluidsynth.

%package src
Summary:	Sample rate converter
Group:		Development/Java
Requires:	%{name}-shared

%description src
Sample rate converter.

%package core
Summary:	Contains public classes and SPI instantiation support
Group:		Development/Java
Requires:	%{name}-shared

%description core
Contains public classes and SPI instantiation support.

%prep
%setup -q
%patch0
%patch1
%patch2
%patch3
%patch4 -p1
%patch5
%patch6
%patch7
%patch8

mv configure.in configure.ac
# (grenoya) The Makefile.in's sepcify to include JAVADIR/include/$(OSNAME) but
# as JAVADIR is set to $(prefix), this ends up being /usr/include/linux in
# several cases. This can cause compile problems as /usr/include/linux should
# not be included directly in the search path. Most notably this breaks
# fluidsynth, but this change is generic and should avoid any such issues 
# elsewhere too.
find -name "Makefile.in" -exec sed -i 's,-I"\?$(JAVADIR)/include"\? -I"\?$(JAVADIR)/include/$(OSNAME)"\?,-I%{_jvmdir}/java/include -I%{_jvmdir}/java/include/linux,g' {} \;
# (grenoya) The libraries are built in a .libs subfolder but this path is not
# used when linking and it can't be found. Can't work out a better way but open
# to suggestions!!
ln -s .libs/org_tritonus_midi_device_fluidsynth_FluidSynthesizer.o src/lib/fluidsynth/
# Makefile.am is not used, so don't keep it around.
rm -f src/lib/fluidsynth/Makefile.am

# Prevent a rebuild in %%install
sed -i 's|install: all|install:|' Makefile.in

autoreconf -vfi

%build
export CFLAGS="%{optflags} -fPIC -I%{_includedir}/cdda"
export CPPFLAGS="%{optflags} -fPIC -I%{_includedir}/cdda"
export CXXFLAGS="%{optflags} -fPIC -I%{_includedir}/cdda"
%configure2_5x

export CLASSPATH=`build-classpath commons-net`
%ant -v -f build-dtd.xml

export CLASSPATH=`build-classpath jl jorbis`
%ant

%__sed -i -e 's|-Wall -Werror||g' \
	src/lib/cdparanoia/Makefile
%__sed -i -e 's|-Wall -Werror||g' \
	src/lib/fluidsynth/Makefile
%__sed -i -e 's|-Wall -Werror||g' \
	src/lib/vorbis/Makefile
%__sed -i -e 's|libtool|libtool --tag=CXX |g' \
	src/lib/fluidsynth/Makefile

%__make \
	JAVADIR=%{_jvmdir}/java

# javadoc doesn't want to process these two files:
rm -f src/classes/org/tritonus/debug/AJDebug*
%javadoc -d javadoc -public -Xdoclint:none `find ./ -name '*.java'`

%install
# jars
%__install -dm 755 %{buildroot}%{_javadir}/%{name}
%__install -pm 644 dist/*.jar %{buildroot}%{_javadir}/%{name}
pushd %{buildroot}%{_javadir}/%{name}
	for jar in *-%{version}*; do
		ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
	done
popd

# native libs
%__install -dm 755 %{buildroot}%{_jvmdir}/jre/lib/ext
pushd dist
	for jar in *-%{version}*; do
		ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
	done
popd

%__make install \
	JAVAEXTPATH=%{buildroot}%{_jvmdir}/jre/lib/ext \
	JAVADIR=%{_jvmdir}/java \
	JAVAEXTLIBPATH=%{buildroot}%{_jvm_lib_ext_dir} \
	DESTDIR=%{buildroot}

# link the tritonus-jar files from %%{javadir}/%%{name} to %%{_jvmdir}/jre/lib/ext
for i in core gsm mp3 remaining share; do
	%add_jvm_extension %{buildroot}%{_javadir}/%{name}/%{name}_$i.jar
done

# directory for native-libraries
%if 0
install -dm 755 %{buildroot}%{_libdir}
install -m 744 libtritonuscommon.so* %{buildroot}%{_libdir}
%endif

# javadoc
%__install -dm 755 %{buildroot}%{_javadocdir}/%{name}
cp -pr javadoc/* %{buildroot}%{_javadocdir}/%{name}

%if 0
# install Mp3Encoder.java
%__install -dm 755 %{buildroot}%{_defaultdocdir}/%{name}-mp3enc
%__install -m 644 %{SOURCE1} \
	%{buildroot}%{_defaultdocdir}/%{name}-mp3enc
%__install -m 644 LGPL \
	%{buildroot}%{_defaultdocdir}/%{name}-mp3enc
%endif

# drop esound support
rm -rf %{buildroot}%{_javadir}/%{name}/%{name}_esd*.jar

%files
%files alsa
%doc LGPL
%doc doc/ALSA*  doc/Alsa*
%doc doc/bindists/alsa/readme.txt
%{_javadir}/%{name}/%{name}_alsa*.jar
%{_jvm_lib_ext_dir}/lib%{name}alsa.so*

%files aos
%doc LGPL
%doc doc/AudioOutput*
%{_javadir}/%{name}/%{name}_aos*.jar

%files cdda
%doc LGPL
%doc doc/cdda.txt
%doc doc/bindists/cdda/readme.txt
%{_javadir}/%{name}/%{name}_cdda*.jar
%{_jvm_lib_ext_dir}/lib%{name}cdparanoia.so*

%files core
%doc LGPL NEWS README
%doc doc/%{name}faq.sgml
%{_javadir}/%{name}/%{name}_core*.jar
%{_jvmdir}/jre/lib/ext/%{name}_core.jar
#%%{_libdir}/lib%%{name}common.so*

%files dsp
%doc LGPL
%{_javadir}/%{name}/%{name}_dsp*.jar

%files fluidsynth
%doc LGPL
%doc doc/fluidsynth*
%{_javadir}/%{name}/%{name}_fluidsynth*.jar
%{_jvm_lib_ext_dir}/lib%{name}fluid.so*

%files gsm
%doc LGPL
%{_javadir}/%{name}/%{name}_gsm*.jar
%{_jvmdir}/jre/lib/ext/%{name}_gsm*.jar

%files javadoc
%doc %{_javadocdir}/%{name}

%files javasequencer
%doc LGPL
%{_javadir}/%{name}/%{name}_javasequencer*.jar

%files jorbis
%doc LGPL
%{_javadir}/%{name}/%{name}_jorbis*.jar

%files misc
%doc LGPL
%{_javadir}/%{name}/%{name}_remaining*.jar
%{_jvmdir}/jre/lib/ext/tritonus_remaining.jar

%files mp3
%doc LGPL
%doc README_mp3
%{_javadir}/%{name}/%{name}_mp3*.jar
%{_jvmdir}/jre/lib/ext/%{name}_mp3.jar

%if 0
%files mp3enc
%doc %{_defaultdocdir}/%{name}-mp3enc/*
%{_jvm_lib_ext_dir}/liblame%{name}.so*
%endif

%files pvorbis
%doc LGPL
%{_javadir}/%{name}/%{name}_pvorbis*.jar

%files shared
%doc LGPL
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{name}_share*.jar
%{_jvmdir}/jre/lib/ext/%{name}_share.jar

%files src
%doc LGPL
%{_javadir}/%{name}/%{name}_src*.jar

%files vorbis
%doc LGPL
%doc doc/bindists/vorbis/readme.txt
%{_javadir}/%{name}/%{name}_vorbis*.jar
%{_jvm_lib_ext_dir}/lib%{name}vorbis.so*


%changelog
* Sun Feb 19 2017 daviddavid <daviddavid> 0.3.7-0.0.20110107.7.mga6
+ Revision: 1086905
- move all jar files from /usr/share/java/ to /usr/share/java/tritonus/
- reenable javadoc build

* Sat Dec 26 2015 daviddavid <daviddavid> 0.3.7-0.0.20110107.6.mga6
+ Revision: 915349
- s/jakarta/apache/ (jakarta is long since dead)

* Wed Oct 15 2014 umeabot <umeabot> 0.3.7-0.0.20110107.5.mga5
+ Revision: 750471
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.3.7-0.0.20110107.4.mga5
+ Revision: 689956
- Mageia 5 Mass Rebuild

* Sun Sep 14 2014 grenoya <grenoya> 0.3.7-0.0.20110107.3.mga5
+ Revision: 675438
- fix patch 7 to allow build against JDK 1.8

* Sun Dec 08 2013 grenoya <grenoya> 0.3.7-0.0.20110107.2.mga4
+ Revision: 555960
- fix build (due to new version of fluidsynth)
- add patch of JDK version check for 1.7

  + umeabot <umeabot>
    - Mageia 4 Mass Rebuild
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

  + luigiwalser <luigiwalser>
    - update java BRs

* Mon May 09 2011 wally <wally> 0.3.7-0.0.20110107.2.mga1
+ Revision: 96650
- drop esound support

* Sat Mar 05 2011 grenoya <grenoya> 0.3.7-0.0.20110107.1.mga1
+ Revision: 65014
- imported package tritonus


* Fri Jan 07 2011 Paulo Andrade <pcpa@mandriva.com.br> 0.3.7-0.0.20110107.1mdv2011.0
+ Revision: 629660
- Regenerate tarball from a fresh cvs checkout
- Correct wrong java extension that did remove the jar and linked a
  link to a link
- Move .jar files to %%_javadir so that /usr/bin/build-classpath and
  related scripts find it
- Also %%if 0 the Requires of tritonus-mp3enc so that the main package
  is installable

* Wed Dec 08 2010 Oden Eriksson <oeriksson@mandriva.com> 0.3.7-0.0.cvs20080107.4mdv2011.0
+ Revision: 615272
- the mass rebuild of 2010.1 packages

* Wed Jan 27 2010 Götz Waschk <waschk@mandriva.org> 0.3.7-0.0.cvs20080107.3mdv2010.1
+ Revision: 497125
- fix build deps
- readd cdparanoia libs

* Sun Sep 20 2009 Thierry Vignaud <tv@mandriva.org> 0.3.7-0.0.cvs20080107.2mdv2010.0
+ Revision: 445552
- rebuild

* Thu Oct 16 2008 Alexander Kurtakov <akurtakov@mandriva.org> 0.3.7-0.0.cvs20080107.1mdv2009.1
+ Revision: 294485
- remove unneeded req
- really fix file list
- br libtool
- fix file list
- import tritonus


